| API Documentation |  |

- MAIN PAGE
- NAMESPACES
- CLASSES

Public Member Functions | List of all members
nkGraphics::RenderScenePass Class Reference

A pass rendering render queues. More...

Inheritance diagram for nkGraphics::RenderScenePass:

## Public Member Functions
RenderQueue * | getRenderQueue () const
Camera * | getRenderCamera () const
Camera * | getCullingCamera () const
Camera * | getLodCamera () const
BlendState * | getBlendState () const
RasterState * | getRasterState () const
DepthStencilState * | getDepthStencilState () const
bool | isTransparentPass () const
void | setRenderQueue (RenderQueue *queue)
void | setRenderCamera (Camera *cam)
void | setCullingCamera (Camera *cam)
void | setLodCamera (Camera *cam)
virtual void | setBlendState (BlendState *state)
virtual void | setRasterState (RasterState *state)
virtual void | setDepthStencilState (DepthStencilState *state)
void | setTransparentPass (bool value)
virtual void | exportClassToTree (nkExport::Node *rootNode) override
virtual void | importClassFromTree (nkExport::Node *rootNode) override
Public Member Functions inherited from nkGraphics::Pass
| Pass (System *system) noexcept
virtual | ~Pass ()
System * | getSystem () const
TargetOperations * | getParent () const
PASS_TYPE | getType () const
nkMemory::StringView | getName () const
void | setParent (TargetOperations *parent)
void | setName (nkMemory::StringView name)
Public Member Functions inherited from nkExport::Exportable
| Exportable () noexcept
virtual | ~Exportable ()

## Detailed Description

A pass rendering render queues.

It uses the meshes within the queues, each having potentially a different shader set using the their Entity.
See TargetOperations::addRenderScenePass() for use.

## Member Function Documentation

## ◆ getRenderQueue()

RenderQueue* nkGraphics::RenderScenePass::getRenderQueue | ( |  | ) | const

Returns
  The special (named) render queue rendered.

## ◆ getRenderCamera()

Camera* nkGraphics::RenderScenePass::getRenderCamera | ( |  | ) | const

Returns
  The rendering cam used for the pass.

## ◆ getCullingCamera()

Camera* nkGraphics::RenderScenePass::getCullingCamera | ( |  | ) | const

Returns
  The culling camera used for the pass.

## ◆ getLodCamera()

Camera* nkGraphics::RenderScenePass::getLodCamera | ( |  | ) | const

Returns
  The LOD camera used for the pass.

## ◆ getBlendState()

BlendState* nkGraphics::RenderScenePass::getBlendState | ( |  | ) | const

Returns
  The blend state used for the pass.

## ◆ getRasterState()

RasterState* nkGraphics::RenderScenePass::getRasterState | ( |  | ) | const

Returns
  The raster state used for the pass.

## ◆ getDepthStencilState()

DepthStencilState* nkGraphics::RenderScenePass::getDepthStencilState | ( |  | ) | const

Returns
  The depth and stencil state used for the pass.

## ◆ isTransparentPass()

bool nkGraphics::RenderScenePass::isTransparentPass | ( |  | ) | const

Returns
  Whether the pass considers transparent rendering (true) or not (false).

## ◆ setRenderQueue()

void nkGraphics::RenderScenePass::setRenderQueue | ( | RenderQueue * | queue | ) |

Sets the render queue to render.

Parameters

  queue | The queue to render.

## ◆ setRenderCamera()

void nkGraphics::RenderScenePass::setRenderCamera | ( | Camera * | cam | ) |

Sets the render camera used for the pass.

Parameters

  cam | The camera to use.

## ◆ setCullingCamera()

void nkGraphics::RenderScenePass::setCullingCamera | ( | Camera * | cam | ) |

Sets the culling camera used for the pass.

Parameters

  cam | The camera to use.

## ◆ setLodCamera()

void nkGraphics::RenderScenePass::setLodCamera | ( | Camera * | cam | ) |

Sets the LOD camera used for the pass.

Parameters

  cam | The camera to use.

## ◆ setBlendState()

virtual void nkGraphics::RenderScenePass::setBlendState | ( | BlendState * | state | ) |
| virtual

Sets the blend state to use for the pass.

Parameters

  state | The state to use.

## ◆ setRasterState()

virtual void nkGraphics::RenderScenePass::setRasterState | ( | RasterState * | state | ) |
| virtual

Sets the raster state to use for the pass.

Parameters

  state | The state to use.

## ◆ setDepthStencilState()

virtual void nkGraphics::RenderScenePass::setDepthStencilState | ( | DepthStencilState * | state | ) |
| virtual

Sets the depth and stencil state to use for the pass.

Parameters

  state | The state to use.

## ◆ setTransparentPass()

void nkGraphics::RenderScenePass::setTransparentPass | ( | bool | value | ) |

Sets whether the pass should consider transparent rendering. Off by default.
Consider leaving it off whenever possible; when rendering transparent meshes rendering cannot be as performant.

Parameters

  value | If transparent meshes will be rendered (true) or not (false).

## ◆ exportClassToTree()

virtual void nkGraphics::RenderScenePass::exportClassToTree | ( | nkExport::Node * | rootNode | ) |
| override virtual

Exports an item into a tree describing its structure and its data.

Parameters

  rootNode | The node into which the object has to write its related information.

Reimplemented from nkGraphics::Pass.

Reimplemented in nkGraphics::MonoMaterialPass.

## ◆ importClassFromTree()

virtual void nkGraphics::RenderScenePass::importClassFromTree | ( | nkExport::Node * | rootNode | ) |
| override virtual

Imports information from a tree which is supposed to describe its structure and data.

Parameters

  rootNode | The root node of the tree holding the information.

Reimplemented from nkGraphics::Pass.

Reimplemented in nkGraphics::MonoMaterialPass.

The documentation for this class was generated from the following file:

- Documentation/Headers/NilkinsGraphics/Passes/RenderScenePass.h